// pac_i8028UW_Power_On.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\lib\pac_i8028U.h"
#pragma comment(lib,"..\\lib\\pac_i8028U.lib")


int _tmain(int argc, _TCHAR* argv[])
{
	int ch, ret=-1, i,slot=-1,status=1;
	char act;
	char GainStr[6][32]={"0~ 5V", "0~ 10V", "+/- 5V", "+/- 10V", "4~ 20mA", "0~ 20mA"};
	short gain =0;
	float fAO=0;
	float POAO=0;

	for(i=0;i< 8;i++)
	{
		ret = pac_i8028U_Init(i);
		if(ret== 0)
		{
			slot = i;
			printf("I-8028UW on slot %d \n",slot);
			break;
		}
	}
	if(slot ==-1)
	{
		printf("There is no I-8028UW on the backplane\n");
		getchar();
		return 0;
	}
again:
	printf("Select Output Range : \n");
	for(i=0;i<6;i++)
			printf("%d : %s \n",i,GainStr[i]);
	// Set gain
	scanf("%d", &gain);
	if(gain >5 || gain <0)
	{
		printf("invalid input\n");
		return 0;
	}
	if(gain>3)
		printf("Please make sure the Jumper is in current operation\n");
	else
		printf("Please make sure the Jumper is in voltage operation\n");
	// Set output value
	printf("Set AO value, between %s \n", GainStr[gain]);
	scanf("%f", &fAO);
	// Set output channel
	printf("Set output channel : \n");
	printf("\t For I-8028UW Channel index 0~7  \n");
	printf("\t For I-8024UW Channel index 0~3  \n");
	scanf("%d", &ch);
	
	// Set Power on mode
	printf("Set Power on mode : \n");
	printf("1 : Power on Value \n");
	printf("2 : Power on as last output value(Retentive \n");
	scanf("%d", &status);
	if(status >2 || status <1)
	{
		printf("invalid input\n");
		return 0;
	}
	pac_i8028U_SetPowerOnEnStatus(slot,status);
	if(status==1)
	{
		// Set Power on output value
		printf("Set a different AO value for Power On value , between %s \n", GainStr[gain]);
		scanf("%f", &POAO);
		
		pac_i8028U_WriteAO(slot,ch,gain,fAO);
		pac_i8028U_WritePowerOn_AO(slot,ch,gain,POAO);
		if(gain>3)
			printf("Now the I-8028UW should output %2.4f ma at CH %d \n",fAO,ch);
		else
			printf("Now the I-8028UW should output %2.4f V at CH %d \n",fAO,ch);
		printf("To test Power on Value, please Reset the Power of PAC \n");
		if(gain>3)
			printf("And the Output will become %2.4f ma at CH %d \n",POAO,ch);
		else
			printf("And the Output will become %2.4f V at CH %d \n",POAO,ch);
	}
	else
	{
		pac_i8028U_WriteAO(slot,ch,gain,fAO);
		printf("To test Power on as last output value(Retentive, please Reset the Power of PAC \n");
		if(gain>3)
			printf("And the Output will hold at %2.4f ma at CH %d \n",fAO,ch);	
		else
			printf("And the Output will hold at %2.4f V at CH %d \n",fAO,ch);	
	}
	getchar();
	getchar();
	return 0;
}

