// pac_i8028UW_Safe_Value.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\lib\pac_i8028U.h"
#pragma comment(lib,"..\\lib\\pac_i8028U.lib")

int _tmain(int argc, _TCHAR* argv[])
{
	int enStatus=1,ifWDT_Overwrite=1,wdtTimeout=0;
	int ch, ret=-1, i,slot=-1,status=1;
	char act;
	char GainStr[6][32]={"0~ 5V", "0~ 10V", "+/- 5V", "+/- 10V", "4~ 20mA", "0~ 20mA"};
	short gain =0,gg;
	float fAO=0,ff;
	float POAO=0;

	for(i=0;i< 8;i++)
	{
		ret = pac_i8028U_Init(i);
		if(ret== 0)
		{
			slot = i;
			printf("I-8028UW on slot %d \n",slot);
			break;
		}
	}
	if(slot ==-1)
	{
		printf("There is no I-8028UW on the backplane\n");
		getchar();
		return 0;
	}	

	printf("Select Output Range : \n");
	for(i=0;i<6;i++)
			printf("%d : %s \n",i,GainStr[i]);
	// Set gain
	scanf("%d", &gain);
	if(gain >5 || gain <0)
	{
		printf("invalid input\n");
		return 0;
	}
	if(gain>3)
		printf("Please make sure the Jumper is in current operation\n");
	//else
		printf("Please make sure the Jumper is in voltage operation\n");
	// Set output value
	printf("Set AO value, between %s \n", GainStr[gain]);
	scanf("%f", &fAO);
	// Set output channel
	printf("Set output channel : \n");
	printf("\t For I-8028UW Channel index 0~7  \n");
	printf("\t For I-8024UW Channel index 0~3  \n");
	scanf("%d", &ch);
	
	// Set Power on output value
	printf("Set a different AO value for Safe Value , between %s \n", GainStr[gain]);
	scanf("%f", &POAO);
	
	pac_i8028U_WriteSafe_AO(slot,ch,gain,POAO);
	pac_i8028U_ReadSafe_AO(slot,ch,&gg,&ff);
	
	// set WDT enable = true
	enStatus = 1;
	// enable Output when WDT timeout
	ifWDT_Overwrite = 0;
	// Set Watch Dog Time
	printf("Please Input WDT timeout value, 1 ~ 16 second \n");
	scanf("%lu", &wdtTimeout);
	
	pac_i8028U_WriteAO(slot,ch,gain,fAO);
	 
	if(gain>3)
	{
		printf("Now the I-8028UW should output %2.4f ma at CH %d \n",fAO,ch);
		printf("The Output will become %2.4f ma at CH %d when watch time out\n",POAO,ch);
	}
	else
	{
		printf("Now the I-8028UW should output %2.4f V at CH %d \n",fAO,ch);
		printf("The Output will become %2.4f V at CH %d when watch dog time out\n",POAO,ch);
	}
	printf("Press any key to start test \n");  
	getchar();
	getchar();
	pac_i8028U_SetModuleWDTConfig(slot,enStatus, wdtTimeout,ifWDT_Overwrite);
	for(i=wdtTimeout+1;i>=0;i--)
	{
		status=pac_i8028U_GetModuleWDTStatus(slot);
		printf("Countdown...%d ,  status %d \r",i,status);
		Sleep(1000);
	}
	getchar();
	return 0;
}


