﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace pac_i8028UW_Power_On
{
    public partial class Form1 : Form
    {
        int slot = 0;
        short FarmVer = 0;
        short LibVer = 0;
        string LibDate = "";
        int ch = 0;
        short range = 0;
        short PWR_range = 0;
        short mode = 0;

        private string[] RangeStr = new string[6];
        private string[] SlotStr = new string[9];
        private string[] ChStr = new string[8];
        private string[] ModeStr = new string[2];

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Description_list.Items.Add("This demo tells the Power On function.");
            Description_list.Items.Add("Please follow the below steps.");
            Description_list.Items.Add("1. Select slot");
            
            RangeStr[0] = "0 ~ 5V";
            RangeStr[1] = "0 ~ 10V";
            RangeStr[2] = "+/- 5V";
            RangeStr[3] = "+/- 10V";
            RangeStr[4] = "4 ~ 20mA";
            RangeStr[5] = "0 ~ 20mA";

            SlotStr[0] = "Slot 0";
            SlotStr[1] = "Slot 1";
            SlotStr[2] = "Slot 2";
            SlotStr[3] = "Slot 3";
            SlotStr[4] = "Slot 4";
            SlotStr[5] = "Slot 5";
            SlotStr[6] = "Slot 6";
            SlotStr[7] = "Slot 7";
            SlotStr[8] = "Auto Search";

            ChStr[0] = "Channel 0";
            ChStr[1] = "Channel 1";
            ChStr[2] = "Channel 2";
            ChStr[3] = "Channel 3";
            ChStr[4] = "Channel 4";
            ChStr[5] = "Channel 5";
            ChStr[6] = "Channel 6";
            ChStr[7] = "Channel 7";
            
            ModeStr[0] = "Power On Value";
            ModeStr[1] = "Power On Retentive";

            for (int i = 0; i < 6; i++)
            {
                Range_cbo.Items.Add(RangeStr[i]);
            }
            for (int i = 0; i < 9; i++)
            {
                SlotIndex_cbo.Items.Add(SlotStr[i]);
            }
            for (int i = 0; i < 8; i++)
            {
                Ch_cbo.Items.Add(ChStr[i]);
            }
            for (int i = 0; i < 6; i++)
            {
                Power_On_Range_cbo.Items.Add(RangeStr[i]);
            }
            for (int i = 0; i < 2; i++)
            {
                ModeIndex_cbo.Items.Add(ModeStr[i]);
            }

            


            LibVer = pac_i8028UNet.pac8028U.LibVersion();
            LibVer_txt.Text = LibVer.ToString("X");
            LibDate = pac_i8028UNet.pac8028U.LibDate();
            LibDate_txt.Text = LibDate;
        }

        private void SlotIndex_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = 0;
            int i = 0;
            string msg = "";
            slot = SlotIndex_cbo.SelectedIndex;
            if (slot == 8)
            {
                for (i = 0; i < 8; i++)
                {
                    ret = pac_i8028UNet.pac8028U.Init(i);
                    if (ret == 0)
                    {
                        slot = i;
                        msg = string.Format("Find Module on slot {0}", slot);
                        MessageBox.Show(msg);
                        break;
                    }
                }
                if (slot == 8)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            else
            {
                ret = pac_i8028UNet.pac8028U.Init(slot);
                if (ret != 0)
                {
                    MessageBox.Show("Cmt not find Module");
                    return;
                }
            }
            pac_i8028UNet.pac8028U.FirmwareVersion(slot, ref FarmVer);
            FirmVer_txt.Text = FarmVer.ToString();
            Description_list.Items.Add("2. Select Power On mode");
            Description_list.Items.Add("Power On Value : ");
            Description_list.Items.Add("Once the power gets shout down and recover, ");
            Description_list.Items.Add("the output will become the value which is set.");
            Description_list.Items.Add(" ");
            Description_list.Items.Add("Power On Retentive : ");
            Description_list.Items.Add("Once the power gets shout down and recover,");
            Description_list.Items.Add("the output will be keep the same.");
        }

        private void ModeIndex_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            mode = (short)(ModeIndex_cbo.SelectedIndex+1);
            pac_i8028UNet.pac8028U.SetPowerOnEnableStatus(slot, mode);
            Description_list.Items.Add("3. Select channel");
            if (mode == 2)
            {
                Power_On_Range_lab.Enabled = false;
                Power_On_Range_lab.Visible = false;
                Power_On_Range_cbo.Enabled = false;
                Power_On_Range_cbo.Visible = false;
                Power_On_AO_lab.Enabled = false;
                Power_On_AO_lab.Visible = false;
                Power_On_AO_txt.Enabled = false;
                Power_On_AO_txt.Visible = false;
            }
            else
            {
                Power_On_Range_lab.Enabled = true;
                Power_On_Range_lab.Visible = true;
                Power_On_Range_cbo.Enabled = true;
                Power_On_Range_cbo.Visible = true;
                Power_On_AO_lab.Enabled = true;
                Power_On_AO_lab.Visible = true;
                Power_On_AO_txt.Enabled = true;
                Power_On_AO_txt.Visible = true;
            }
        }

        private void Ch_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            ch = Ch_cbo.SelectedIndex;
            Description_list.Items.Add("4. Select output range and input output value");
        }

        private void Range_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            range = (short)Range_cbo.SelectedIndex;
        }

        private void AO_txt_TextChanged(object sender, EventArgs e)
        {
            if (mode == 2)
            {
                Description_list.Items.Add("5. Click 'Set' button");
            }
            else
            {
                Description_list.Items.Add("5. Select Power On Value output range and");
                Description_list.Items.Add("input Power On Value output value");
            }
        }

        private void Power_On_AO_txt_TextChanged(object sender, EventArgs e)
        {
            Description_list.Items.Add("6. Click 'Set' button");
        }

        private void Power_On_Range_cbo_SelectedIndexChanged(object sender, EventArgs e)
        {
            PWR_range = (short)Power_On_Range_cbo.SelectedIndex;
        }

        private void btnSet_Click(object sender, EventArgs e)
        {
            float ao = 0;
            float PWR_ao = 0;
            ao = float.Parse(AO_txt.Text);
            pac_i8028UNet.pac8028U.WriteAO(slot, ch, range, ao);
            if (mode == 1)
            {
                PWR_ao = float.Parse(Power_On_AO_txt.Text);
                pac_i8028UNet.pac8028U.WritePowerOn_AO(slot, ch, range, PWR_ao);
            }

            if (mode == 2)
            {
                Description_list.Items.Add("Now, the output should change to 'Output Value'");
                Description_list.Items.Add("To test Power on Value, please Reset the Power of PAC");
                Description_list.Items.Add("And the Output will keep the same");
            }
            else
            {
                Description_list.Items.Add("Now, the output should change to 'Output Value'");
                Description_list.Items.Add("To test Power on Value, please Reset the Power of PAC");
                Description_list.Items.Add("And the Output will change to 'Power On Value'");
            }
            
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}
